"""
@author: Mario Lassnig
@contact: mlassnig@cern.ch
@since: 0.3
@version: $Id: DeleteDatasetSubscription.py,v 1.7 2009/10/06 13:23:17 angelos Exp $
"""

import cliutil

from dq2.common.cli.DQDashboardTool import DQDashboardTool

from dq2.clientapi.cli.cliutil import getDQ2, option_value


class DeleteDatasetSubscription(DQDashboardTool):
    """
    @since: 0.3.0
    """

    usage = '%prog [options] <DATASET> <SITENAME>'
    
    version = '$Revision: 1.7 $'
    
    description = 'Delete Subscription of Dataset'

    toolOptions = [
        cliutil.opt_dataset_version
    ]

    
    def __init__ (self):
        """
        @since: 0.3.0
        """
        DQDashboardTool.__init__(self)


    def _get_parameters (self):
        """
        @since: 0.3.0
        """
        return (self.args[0], self.args[1])


    def execute (self):
        """
        @since: 0.3.0
        """
        
        dq = getDQ2(self)
        
        dsn, site = self._get_parameters()
        
        dq.deleteDatasetSubscription(dsn, site, int(self.options.version))
                    
        if self.options.version > 0:
            print 'Subscription for dataset %s version %s replica at %s deleted' % (dsn, self.options.version, site)
        else:
            print 'Subscription for dataset %s replica at %s deleted' % (dsn, site)
        

    