"""
@author: Mario Lassnig
@contact: mlassnig@cern.ch
@since: 0.3
@version: $Id: DeleteFilesFromDataset.py,v 1.4 2009/10/06 13:23:17 angelos Exp $
"""

from dq2.common.cli.DQDashboardTool import DQDashboardTool

from dq2.clientapi.cli.cliutil import getDQ2, option_value


class DeleteFilesFromDataset (DQDashboardTool):
    """
    @since: 0.3.0
    """

    usage = "%prog [options] <DATASET> <GUID> ... <GUID>"
    
    version = "$Revision: 1.4 $"
    
    description = "Delete Files From Dataset"

    toolOptions = []


    def __init__ (self):
        """
        @since: 0.3.0
        """
        DQDashboardTool.__init__(self)


    def _get_parameters (self):
        """
        @since: 0.3.0
        """
        return (self.args[0], self.args[1:])


    def execute (self):
        """
        @since: 0.3.0
        """
    
        dq = getDQ2(self)
        
        dsn, files = self._get_parameters()
        
        dq.deleteFilesFromDataset(dsn, files)
        
        print "Files %s deleted from dataset %s" % (str(files), dsn)