"""
@author: Mario Lassnig
@contact: mlassnig@cern.ch
@since: 0.3
@version: $Id: ListDatasets.py,v 1.6 2009/10/06 13:23:17 angelos Exp $
"""

import cliutil

from dq2.common                     import optparse
from dq2.common.cli.DQDashboardTool import DQDashboardTool
from dq2.clientapi.cli.cliutil      import getDQ2


class ListDatasets (DQDashboardTool):

    usage = "%prog [options] <DATASET> "
    
    version = "$Revision: 1.6 $"
    
    description = "List Datasets"

    toolOptions = [
        cliutil.opt_dataset_version,
        optparse.make_option(
                             "-r", "--resultPerPage",
                             dest="rpp",
                             default=None,
                             type='int',
                             help="Print rrp first results"),
       optparse.make_option(
                            "-p", "--page",
                            dest="p",
                            default=None,
                            type='int',
                            help="Specify page to print"),        
    ]

    def __init__ (self):
        """
        @since: 0.3.0
        """
        DQDashboardTool.__init__(self)
        
        
    def _get_parameters (self):
        """
        @since: 0.3.0
        """
        return self.args[0]

        
    def execute (self):
        """
        @since: 0.3.0
        """
        
        dq = getDQ2(self)
        
        dsn = self._get_parameters()
        
        out = ''        
        ret = dq.listDatasets(dsn, version=self.options.version, onlyNames=True, p=self.options.p, rpp=self.options.rpp)
        
        for ds in ret:
            print ds 
