"""
@author: Pedro Salgado
@contact: pedro.salgado@cern.ch
@since: 0.3
@version: $Id: ListDatasetsInContainer.py,v 1.2 2009/10/06 13:23:18 angelos Exp $
"""

import sys
import cliutil

from dq2.common.cli.DQDashboardTool import DQDashboardTool

from dq2.clientapi.cli.cliutil import getDQ2


class ListDatasetsInContainer (DQDashboardTool):
    """
    @since: 0.3.0
    """

    usage = "%prog <DATASET> "
    
    version = "$Revision: 1.2 $"
    
    description = "List Datasets In Container"

    toolOptions = []
    
    
    def __init__ (self):
        """
        @since: 0.3.0
        """
        DQDashboardTool.__init__(self)


    def _get_parameters (self):
        """
        @since: 0.3.0
        """
        return self.args[0]


    def execute (self):
        """
        @since: 0.3.0
        """
        
        dq = getDQ2(self)
        
        
        name = self._get_parameters()
        
        ret = dq.listDatasetsInContainer(name)
        
        for dataset in ret:
            print dataset