"""
(since 0.3.0)
"""

from dq2.common import optparse
from dq2.common.cli.DQDashboardTool import DQDashboardTool

from dq2.clientapi.cli                  import cliutil
from dq2.clientapi.cli.cliutil          import getDQ2

from dq2.location.DQLocationConstants import LocationState

class ListDeletedReplicas (DQDashboardTool):
    """
    (since 0.3.0)
    """

    usage = "%prog [options] <SITENAME> "
    
    version = "$Revision: 1.2 $"
    
    description = "List Datasets In Site"

    toolOptions = [
                   optparse.make_option(
                    "-r", "--resultPerPage",
                    dest="rpp",
                    default=None,
                    type='int',
                    help="Print rrp first results"),
                   optparse.make_option(
                    "-p", "--page",
                    dest="p",
                    default=None,
                    type='int',
                    help="Specify page to print"),
                    optparse.make_option(
                    "-n", "--name",
                    dest="name",
                    default=None,
                    type='str',
                    help="Specify a dataset name pattern")
                    
    ]
    
    
    def _get_parameters (self):
        """
        (since 0.3.0)
        """
        return self.args[0]
 
    
    def __init__ (self):
        """
        (since 0.3.0)
        """
        DQDashboardTool.__init__(self)
    
    
    def _get_parameters (self):
        """
        (since 0.3.0)
        """
        return self.args[0]
        
        
    def execute(self):
        """
        (since 0.3.0)
        """

        dq = getDQ2(self)
    
        location = self._get_parameters()
        
        out = ''
        ret = dq.listDeletedReplicas(location=location, name=self.options.name, p=self.options.p, rpp=self.options.rpp)
              
        for dsn in ret:
            print '%s' % (dsn)