"""
@author: Mario Lassnig
@contact: mlassnig@cern.ch
@since: 0.3
@version: $Id: ListErasedDatasets.py,v 1.2 2009/10/06 13:23:17 angelos Exp $
"""

from dq2.common.cli.DQDashboardTool import DQDashboardTool
from dq2.common.DQException import DQException
from dq2.common.DQConstants import DatasetState

from dq2.clientapi.cli.cliutil import getDQ2


class ListErasedDatasets (DQDashboardTool):
    """
    @since: 0.3.0
    """

    usage = "%prog"
    
    version = "$Revision: 1.2 $"
    
    description = 'List Erased Datasets'

    toolOptions = []


    def __init__(self):
        """
        @since: 0.3.0
        """
        DQDashboardTool.__init__(self)


    def execute(self):
        """
        @since: 0.3.0
        """
        
        dq = getDQ2(self)
        
        
        filter = {'state': DatasetState.DELETED}
        
        ret = dq.listDatasetsByMetaData(filter)
        
        for i in ret:
            print i