"""
(since 0.3.1)
"""

import cliutil

from dq2.common import optparse
from dq2.common.DQDashboardTool import DQDashboardTool

from dq2.clientapi.cli.cliutil import getDQ2

from dq2.location.DQLocationConstants import LocationState

class RegisterDatasetReplicaConsistencyCheck (DQDashboardTool):
    """
    (since 0.3.1)
    """

    usage = "%prog [options] <DATASET> <SITENAME> "
    
    version = "$Revision: 1.1 $"
    
    description = "List Dataset Replica State In Site"

    toolOptions = [cliutil.opt_dataset_version]    
    
    def _get_parameters (self):
        """
        (since 0.3.1)
        """
        return self.args[0]
 
    
    def __init__ (self):
        """
        (since 0.3.0)
        """
        DQDashboardTool.__init__(self)        
    
    def _get_parameters (self):
        """
        (since 0.3.1)
        """
        return (self.args[0], self.args[1])
                
    def execute(self):
        """
        (since 0.3.1)
        """

        dq = getDQ2(self)
            
        dsn, location = self._get_parameters()         
        
        dq.registerDatasetReplicaConsistencyCheck(location=location, dsn=dsn, version=self.options.version)