"""

@author: Pedro Salgado
@contact: pedro.salgado@cern.ch
@since: 1.0
@version: $Id: RegisterDatasetsInContainer.py,v 1.3 2010/01/12 10:28:30 angelos Exp $
"""


from dq2.common.cli.DQDashboardTool import DQDashboardTool
from dq2.clientapi.cli.cliutil import getDQ2
from dq2.repository.DQRepositoryException import DQOpenedDatasetException, DQClosedDatasetException


class RegisterDatasetsInContainer (DQDashboardTool):
    """
    @since: 1.0
    """


    description = 'Registers datasets in container'
    toolOptions = []
    usage = '%prog [options] <CONTAINER> (dataset)'
    version = '$Revision: 1.3 $'


    def __init__(self):
        """
        Constructs a RegisterDatasetsInContainer instance.
        
        @since: 1.0
        @version: $Revision: 1.3 $
        """
        DQDashboardTool.__init__(self)


    def _get_parameters (self):
        """
        @since: 1.0
        """
        return (self.args[0], self.args[1:])


    def execute (self):
        """
        @since: 1.0
        """
        

        
        dq = getDQ2(self)
        
        container, datasets = self._get_parameters()
        
        try:
            dq.registerDatasetsInContainer(container, datasets)
            print 'Container %s has been updated.' % (container)
        except DQOpenedDatasetException:
            print "Open Datasets detected. Datasets need to be frozen before they can be added to containers"
        except DQClosedDatasetException:
            print "Closed Datasets detected. Datasets need to be frozen before they can be added to containers"